//
//  MapView.m
//  Awars III
//
//  Created by Killery on 2012/12/15.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import "MapView.h"

@implementation MapView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        time0  = [NSTimer
                 scheduledTimerWithTimeInterval:0.05f
                 target:self
                 selector:@selector(EventLoop00:)
                 userInfo:nil
                 repeats:YES
                 ];
        chip = [[self LoadImage:@"マス.png"] retain];
        NSRect seRect;
        seRect.size.height = 20*32;
        seRect.size.width = 20*32;
        
        for (int i = 0; i < 20;i++)
            for (int j = 0;j< 20;j++)
                buildNum[i][j] = -1;
        for (int i = 0; i < 20;i++)
            for (int j = 0;j< 20;j++)
                unitNum[i][j] = -1;
        
        [self setFrame:seRect];
    }
    
    return self;
}
-(void)EventLoop00:(NSTimer*)time{
    
    [self setNeedsDisplay:YES];
}


-(BOOL)isFlipped{
    return YES;
}

-(NSImage*)LoadImage:(NSString*)name{
    NSImage *image = [NSImage imageNamed:name];
    if(image == nil) return nil;
    [image setFlipped:[self isFlipped]];
    
    return image;
}
-(void)DrawImage:(NSImage*)image x:(float)x y:(float)y cx:(int)cx cy:(int)cy{
    NSRect frRect;
    frRect.size.height = 32;
    frRect.size.width = 32;
    
    frRect.origin.x = 0;
    frRect.origin.y = 0;
    
    NSRect drRect;
    drRect.origin.x = x;
    drRect.origin.y = y;
    drRect.size.height = 32;
    drRect.size.width = 32;
    
    [image drawInRect:drRect fromRect:frRect operation:NSCompositeSourceOver fraction:1.0f];
    
}

-(void)mouseDown:(NSEvent *)theEvent{
    drugPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    
    posX = (int)drugPoint.x/32;
    posY = (int)drugPoint.y/32;
    
    if(SLSx == 0) chipNum[posX][posY] = SLindex;
    if(SLSx == 1) buildNum[posX][posY] = SLindexB;
    if(SLSx == 2) unitNum[posX][posY] = SLindexU;
    
}

-(void)mouseDragged:(NSEvent *)theEvent{
    drugPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    
    posX = (int)drugPoint.x/32;
    posY = (int)drugPoint.y/32;
    
    if(SLSx == 0) chipNum[posX][posY] = SLindex;
    if(SLSx == 1) buildNum[posX][posY] = SLindexB;
    if(SLSx == 2) unitNum[posX][posY] = SLindexU;

}

- (void)drawRect:(NSRect)dirtyRect
{
    int bx, by;
    for(bx=0;bx<20;bx++){
        for(by=0;by<20;by++){
            [self DrawImage:chip x:bx*32 y:by*32 cx:bx cy:by];
            [self DrawImage:MC[chipNum[bx][by]].img x:bx*32 y:by*32 cx:bx cy:by];
            if(buildNum[bx][by] >= 0) [self DrawImage:BC[buildNum[bx][by]].img x:bx*32 y:by*32 cx:bx cy:by];
            if(unitNum[bx][by] >= 0) [self DrawImage:UC[unitNum[bx][by]].img x:bx*32 y:by*32 cx:bx cy:by];
        }
    
    }
}

@end
