//
//  UnitChipList.h
//  Awars III
//
//  Created by Killery on 2012/12/17.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MapEditor.h"

typedef struct _RESIST{

    int blow;
    int slash;
    int stub;
    int arrow;
    int gun;
    int shell;
    
    int flame;
    int cold;
    int electoric;
    int air;
    int water;
    int gas;
    int holy;
    int dark;
    int explosion;
    int blood;
    
    int paralysis;
    int confusion;
    int poison;
    int sleep;
    int charm;
    int silent;
    
    
}RESIST;

typedef struct _DAMAGE{

    int type;
    double count;
    double pCount;
    
    RESIST R;
    int seed;
    int sort;
    
    bool continium;
    bool absolute;
    bool beam;
    bool noSizeFix;

    struct _DAMAGE *next;
    int index;
}DAMAGE;

typedef struct _DMGEXTEND{

    int rate;
    int hit;

    struct _DMGEXTEND *next;
    int index;
}DMGEXTEND;

typedef struct _ATTACK{

    NSString *name;
    NSString *nameID;
    
    int rangeA;
    int rangeB;
    int extent;
    
    int costType;
    
    double MP;
    double AP;
    double HP;
    
    int pMP;
    int pAP;
    int pHP;
    
    int bullet;
    int hitCount;
    int successRate;
    int vigor;
    int hitPercent;
    
    int type;
    bool trig;
    bool melee;
    bool P;
    bool dmgExtend;
    
    int cSupply;
    int cFood;
    int cMoney;
    
    int riku;
    int chu;
    int umi;
    int sora;
    
    NSString *cmd;
    NSString *msg;
    
    DAMAGE *D;
    DMGEXTEND *E;
    
    
    struct _ATTACK *next;
    int index;
    
}ATTACK;

typedef struct _EQUIP{
    NSString *name;
    NSString *nameRecognition;
    NSString *nameID;
    
    double Weight;
    double price;
    
    double HP;
    double MP;
    double AP;
    double WT;
    double BP;
    
    double STR;
    double VIT;
    double AGI;
    double DEX;
    double MEN;
    double INT;
    double LUK;
    
    int pSTR;
    int pVIT;
    int pAGI;
    int pDEX;
    int pMEN;
    int pINT;
    int pLUK;
    
    int MOV;
    int type;
    
    double recHP;
    int recpHP;
    double recMP;
    int recpMP;
    
    NSString *comment;
    
    RESIST R;
    
}EQUIP;


typedef struct _UNITCHIP{
    
    NSString *name;
    NSString *nameNick;
    NSString *nameClass;
    NSString *nameRecognition;
    NSString *nameID;
    
    double HP;
    double MP;
    double AP;
    double WT;
    double BP;
    
    double STR;
    double VIT;
    double AGI;
    double DEX;
    double MEN;
    double INT;
    double LUK;
    
    double MEL;
    double MIS;
    double HIT;
    double DOD;
    double REA;
    double SKI;
    
    int MOV;
    int typeMONS;
    int typeMOVE;
    
    double ATK;
    double DEF;
    double CAP;
    double ACU;
    double EVA;
    
    int cSupply;
    int cFood;
    int cMoney;
    
    NSString *iName;
    NSImage *img;
    
    NSString *iNameb;
    NSImage *imgb;
    
    RESIST R;
    
    EQUIP eHead;
    EQUIP eHandL;
    EQUIP eHandR;
    EQUIP eBody;
    EQUIP eArm;
    EQUIP eFoot;
    
    NSString *aName;
    ATTACK *A;
    int attackListNum;
    
}UNITCHIP;

UNITCHIP UC[4096];

EQUIP EQ[4096];
EQUIP nilEquip;

@interface UnitChipList : NSObject
{
    NSTimer *UCLtime;
    IBOutlet NSPanel* UCLPanel;
    IBOutlet NSPanel* UCLDetailPanel;
    NSPoint UCLDpoint;
    
    
    NSMutableArray *unitChipListMA;
    IBOutlet NSArrayController *unitChipListAC;
    IBOutlet NSTableView *unitChipListTV;
    
    NSMutableArray *equipItemMA;
    IBOutlet NSArrayController *equipItemAC;
    IBOutlet NSTableView *equipItemTV;
    NSInteger pubEquipItemIndex;
    
    NSArray *fileDataArray;
    NSInteger chipNumb;
    NSInteger itemNumb;
    
    IBOutlet NSPanel* UCLPanelSkill;
    IBOutlet NSPanel* UCLPanelAttack;
    IBOutlet NSPanel* UCLPanelRegist;
    NSPoint windowPoint;
    
    IBOutlet NSPanel* UCLPanelAttackDetail;
    
    IBOutlet NSPanel* UCLPanelEquipList;
    IBOutlet NSPanel* UCLPanelSkillList;
    
    IBOutlet NSPanel* UCLPanelEquipDetail;
    IBOutlet NSPanel* UCLPanelSkillDetail;
    
    NSMutableArray *attackListMA;
    IBOutlet NSArrayController *attackListAC;
    IBOutlet NSTableView *attackListTV;
    
    NSMutableArray *damageListMA;
    IBOutlet NSArrayController *damageListAC;
    IBOutlet NSTableView *damageListTV;
    
    NSMutableArray *hitListMA;
    IBOutlet NSArrayController *hitListAC;
    IBOutlet NSTableView *hitListTV;
    
    NSMutableArray *equipListMA;
    IBOutlet NSArrayController *equipListAC;
    IBOutlet NSTableView *equipListTV;
    
    NSMutableArray *skillListMA;
    IBOutlet NSArrayController *skillListAC;
    IBOutlet NSTableView *skillListTV;
    
    
    IBOutlet NSTextField *TFname;
    IBOutlet NSTextField *TFnameN;
    IBOutlet NSTextField *TFnameR;
    IBOutlet NSTextField *TFnameID;
    IBOutlet NSTextField *TFnameC;
    
    IBOutlet NSTextField *TFhp;
    IBOutlet NSTextField *TFmp;
    IBOutlet NSTextField *TFap;
    IBOutlet NSTextField *TFwt;
    
    IBOutlet NSTextField *TFbp;
    IBOutlet NSTextField *TFatk;
    IBOutlet NSTextField *TFdef;
    IBOutlet NSTextField *TFcap;
    IBOutlet NSTextField *TFacu;
    IBOutlet NSTextField *TFeva;
    
    IBOutlet NSTextField *TFstr;
    IBOutlet NSTextField *TFvit;
    IBOutlet NSTextField *TFagi;
    IBOutlet NSTextField *TFdex;
    IBOutlet NSTextField *TFmen;
    IBOutlet NSTextField *TFint;
    IBOutlet NSTextField *TFluk;
    IBOutlet NSTextField *TFmov;
    
    IBOutlet NSTextField *TFmel;
    IBOutlet NSTextField *TFmis;
    IBOutlet NSTextField *TFhit;
    IBOutlet NSTextField *TFdod;
    IBOutlet NSTextField *TFrea;
    IBOutlet NSTextField *TFski;

    IBOutlet NSTextField *TFcSupply;
    IBOutlet NSTextField *TFcFood;
    IBOutlet NSTextField *TFcMoney;
    
    IBOutlet NSPopUpButton *PUPtMons;
    IBOutlet NSPopUpButton *PUPtMove;
    IBOutlet NSPopUpButton *PUPtEquip;
    
    IBOutlet NSImageView *IVimg;
    IBOutlet NSImageView *IVimgBig;
    
    
    IBOutlet NSTextField *ILTFname;
    IBOutlet NSTextField *ILTFnameR;
    IBOutlet NSTextField *ILTFnameID;
    
    IBOutlet NSTextField *ILTFweight;
    IBOutlet NSTextField *ILTFprice;
    IBOutlet NSTextField *ILTFMOV;
    IBOutlet NSTextField *ILTFHP;
    IBOutlet NSTextField *ILTFMP;
    IBOutlet NSTextField *ILTFAP;
    IBOutlet NSTextField *ILTFWT;
    
    IBOutlet NSTextField *ILTFSTR;
    IBOutlet NSTextField *ILTFVIT;
    IBOutlet NSTextField *ILTFAGI;
    IBOutlet NSTextField *ILTFDEX;
    IBOutlet NSTextField *ILTFMEN;
    IBOutlet NSTextField *ILTFINT;
    IBOutlet NSTextField *ILTFLUK;
    
    IBOutlet NSTextField *ILTFpSTR;
    IBOutlet NSTextField *ILTFpVIT;
    IBOutlet NSTextField *ILTFpAGI;
    IBOutlet NSTextField *ILTFpDEX;
    IBOutlet NSTextField *ILTFpMEN;
    IBOutlet NSTextField *ILTFpINT;
    IBOutlet NSTextField *ILTFpLUK;
    
    IBOutlet NSTextField *ILTFblow;
    IBOutlet NSTextField *ILTFslash;
    IBOutlet NSTextField *ILTFstub;
    IBOutlet NSTextField *ILTFarrow;
    IBOutlet NSTextField *ILTFgun;
    IBOutlet NSTextField *ILTFshell;
    IBOutlet NSTextField *ILTFparalysis;
    IBOutlet NSTextField *ILTFpoison;
    IBOutlet NSTextField *ILTFcharm;
    IBOutlet NSTextField *ILTFconfusion;
    IBOutlet NSTextField *ILTFsleep;
    IBOutlet NSTextField *ILTFsilent;
    
    IBOutlet NSTextField *ILTFflame;
    IBOutlet NSTextField *ILTFcold;
    IBOutlet NSTextField *ILTFelectoric;
    IBOutlet NSTextField *ILTFair;
    IBOutlet NSTextField *ILTFwater;
    IBOutlet NSTextField *ILTFgas;
    IBOutlet NSTextField *ILTFholy;
    IBOutlet NSTextField *ILTFdark;
    IBOutlet NSTextField *ILTFexplosion;
    IBOutlet NSTextField *ILTFblood;
    
    IBOutlet NSTextField *ILTFrecHP;
    IBOutlet NSTextField *ILTFrecHPp;
    IBOutlet NSTextField *ILTFrecMP;
    IBOutlet NSTextField *ILTFrecMPp;
    IBOutlet NSTextField *ILTFcomment;
    
    IBOutlet NSPopUpButton *ILPUBtype;
    
    IBOutlet NSTextField *ALTFname;
    IBOutlet NSTextField *ALTFrangeA;
    IBOutlet NSTextField *ALTFrangeB;
    IBOutlet NSTextField *ALTFextend;
    IBOutlet NSPopUpButton *ALPUBcost;
    IBOutlet NSPopUpButton *ALPUBwType;
    IBOutlet NSTextField *ALTFcost;
    IBOutlet NSTextField *ALTFcostP;
    
    IBOutlet NSTextField *ALTFbullet;
    IBOutlet NSTextField *ALTFhitCount;
    IBOutlet NSTextField *ALTFsuccessRate;
    IBOutlet NSTextField *ALTFvigor;
    IBOutlet NSTextField *ALTFhitRate;
    
    IBOutlet NSButton *ALTFtrigger;
    IBOutlet NSButton *ALTFmelee;
    IBOutlet NSButton *ALTFpass;
    IBOutlet NSButton *ALTFdmgExtent;
    
    IBOutlet NSPopUpButton *ALPUBriku;
    IBOutlet NSPopUpButton *ALPUBchu;
    IBOutlet NSPopUpButton *ALPUBumi;
    IBOutlet NSPopUpButton *ALPUBsora;
    
    IBOutlet NSTextField *ALTFcSupply;
    IBOutlet NSTextField *ALTFcFood;
    IBOutlet NSTextField *ALTFcMoney;
    IBOutlet NSTextField *ALTFcmd;
    IBOutlet NSTextField *ALTFmsg;
    
    IBOutlet NSTextField *ALTFrate;
    IBOutlet NSTextField *ALTFhit;
    
    IBOutlet NSPopUpButton *ALPUBtype;
    IBOutlet NSPopUpButton *ALPUBseed;
    IBOutlet NSPopUpButton *ALPUBsort;
    IBOutlet NSTextField *ALTFdmgCount;
    IBOutlet NSTextField *ALTFdmgRate;
    
    IBOutlet NSButton *ALTFcontinuum;
    IBOutlet NSButton *ALTFabsolute;
    IBOutlet NSButton *ALTFbeam;
    IBOutlet NSButton *ALTFnoSizeFix;
    
}

-(IBAction)submit:(id)sender;
- (NSMutableArray*)unitChipListMA;

-(IBAction)saveUCL:(id)sender;
-(IBAction)cancelUCL:(id)sender;

-(IBAction)mobileUCL:(id)sender;
-(IBAction)skillUCL:(id)sender;
-(IBAction)equiplUCL:(id)sender;

-(IBAction)skillListBtnUCL:(id)sender;
-(IBAction)attackListBtnlUCL:(id)sender;
-(IBAction)registListBtnlUCL:(id)sender;

-(IBAction)equipItemSelected:(id)sender;
-(IBAction)insertEquip:(id)sender;
-(IBAction)removeEquip:(id)sender;

-(IBAction)skillListBtnSubmitUCL:(id)sender;
-(IBAction)attackListBtnSubmitlUCL:(id)sender;
-(IBAction)registListBtnlSubmitUCL:(id)sender;

-(IBAction)insertSkillUCL:(id)sender;
-(IBAction)removeSkillUCL:(id)sender;

-(IBAction)UCLPanelEquipListSubmitBtn:(id)sender;
-(IBAction)UCLPanelSkillListSubmitBtn:(id)sender;

-(IBAction)UCLPanelEquipListOpenBtn:(id)sender;
-(IBAction)UCLPanelSkillListOpenBtn:(id)sender;

-(IBAction)saveIL:(id)sender;
-(IBAction)canceIL:(id)sender;

-(IBAction)insertAttackList:(id)sender;
-(IBAction)removeAttackList:(id)sender;
-(IBAction)insertComboList:(id)sender;
-(IBAction)removeComboList:(id)sender;

-(IBAction)submitAttackList:(id)sender;

-(IBAction)insertDamageList:(id)sender;
-(IBAction)removeDamageList:(id)sender;
-(IBAction)insertHitList:(id)sender;
-(IBAction)removeHitList:(id)sender;

@end
